CSV::Row - Crystal 1.16.3

# struct CSV::Row

- CSV::Row
- Struct
- Value
- Object

##
Overview

A Row of a `CSV::WithHeaders` instance.

##
Defined in:

csv.cr

##
Instance Method Summary

- #[](header : String) : String

  Returns the current row's value corresponding to the given header name.

- #[](column : Int) : String

  Returns this row's value at the given column index.

- #[](header_pattern : Regex, *, options : Regex::MatchOptions = Regex::MatchOptions::None) : String

  Returns this row's value corresponding to the given header_pattern.

- #[]?(header : String) : String | Nil

  Returns this row's value corresponding to the given header name.

- #[]?(column : Int) : String | Nil

  Returns this row's value at the given column index.

- #[]?(header_pattern : Regex, *, options : Regex::MatchOptions = Regex::MatchOptions::None) : String | Nil

  Returns this row's value corresponding to the given header_pattern.

- #size : Int32

  Returns the number of columns in this row, regardless of the number of headers (if requested).

- #to_a : Array(String)

  Converts this row to an `Array`.

- #to_h : Hash(String, String)

  Converts this row to a `Hash`.

- #values_at(*columns : Int)

  Returns a tuple of this row's values at given indices A negative index counts from the end.

- #values_at(*headers : String)

  Returns a tuple of this row's values corresponding to the given headers Raises `KeyError` if any header doesn't exist.

### Instance methods inherited from struct `Struct`

==(other) : Bool ==, hash(hasher) hash, inspect(io : IO) : Nil inspect, pretty_print(pp) : Nil pretty_print, to_s(io : IO) : Nil to_s

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Instance Method Detail

def [](header : String) : String #

Returns the current row's value corresponding to the given header name. Raises `KeyError` if no such header exists. Raises `CSV::Error` if headers were not requested.

def [](column : Int) : String #

Returns this row's value at the given column index. A negative index counts from the end. Raises `IndexError` if no such column exists.

def [](header_pattern : Regex, *, options : Regex::MatchOptions = Regex::MatchOptions::None) : String #

Returns this row's value corresponding to the given header_pattern. Raises `KeyError` if no such header exists. Raises `CSV::Error` if headers were not requested.

def []?(header : String) : String | Nil #

Returns this row's value corresponding to the given header name. Returns `nil` if no such header exists. Raises `CSV::Error` if headers were not requested.

def []?(column : Int) : String | Nil #

Returns this row's value at the given column index. A negative index counts from the end. Returns `nil` if no such column exists.

def []?(header_pattern : Regex, *, options : Regex::MatchOptions = Regex::MatchOptions::None) : String | Nil #

Returns this row's value corresponding to the given header_pattern. Returns `nil` if no such header exists. Raises `CSV::Error` if headers were not requested.

def size : Int32 #

Returns the number of columns in this row, regardless of the number of headers (if requested).

def to_a : Array(String) #

Converts this row to an `Array`.

def to_h : Hash(String, String) #

Converts this row to a `Hash`.

def values_at(*columns : Int) #

Returns a tuple of this row's values at given indices A negative index counts from the end. Raises `IndexError` if any column doesn't exist The behavior of returning a tuple is similar to `Hash#values_at`

def values_at(*headers : String) #

Returns a tuple of this row's values corresponding to the given headers Raises `KeyError` if any header doesn't exist. Raises `CSV::Error` if headers were not requested The behavior of returning a tuple is similar to `Hash#values_at`